# -*- coding: utf-8 -*-
# Wendelin.bigfile | BigFile ZODB backend
# Copyright (C) 2014-2019  Nexedi SA and Contributors.
#                          Kirill Smelkov <kirr@nexedi.com>
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.

# cython: language_level=2
# distutils: language=c++

"""XXX"""

cdef extern from "wcfs/internal/wcfs.h":
    pass

#from wendelin.bigfile import BigFile
# XXX C++ does not understand -fplan9-extensions
"""
cdef extern from "bigfile/_bigfile.h":
    ctypedef extern class wendelin.bigfile._bigfile.BigFile[object PyBigFile]:
        pass
"""
# FIXME hack, keep in sync with PyBigFile
cdef extern from *:
    """
    #include <wendelin/bigfile/file.h>
    #include <wendelin/bigfile/virtmem.h>

    struct CXXPyBigFile {
        PyObject pyobj;
        BigFile  file;
    };
    """
    struct CXXPyBigFile:
        pass
    ctypedef extern class wendelin.bigfile._bigfile.BigFile[object CXXPyBigFile]:
        pass


# helper for ZBigFile - just redirect loadblk/storeblk back
# (because it is not possible to inherit from both Persistent and BigFile at
#  the same time - see below)
cdef class _ZBigFile(BigFile):
    # .zself    - reference to ZBigFile

    """
    def __new__(cls, zself, blksize):
        obj = BigFile.__new__(cls, blksize)
        obj.zself = zself
        return obj
    """

    def __cinit__(self, zself, blksize):
        BigFile.__cinit__(self, blksize)
        self.zself = zself

    # redirect load/store/mapper to main class
    def loadblk(self, blk, buf):    return self.zself.loadblk(blk, buf)
    def storeblk(self, blk, buf):   return self.zself.storeblk(blk, buf)
    #def blkmmapper(self):           return self.zself.blkmmapper()
